/* Copyright 1989-93 GROUPE BULL -- See license conditions in file COPYRIGHT */

/***************************************************************************
 * isync.c
 *
 * Parse and execute the 'sync' command
 ***************************************************************************/

#include <stdio.h>

#include "interp.h"
#include "kediti.h"

static char *documentation =
"sync [true/false]\n\
With no argument this command issue a round-trip to target server, making\n\
sure that all bufferized requests are sent and managed.\n\
If an argument is provided, the connection is turn into sync, or async mode.\n\
In sync mode, a round-trip is initiated after each request. This is very\n\
similar to the X sync stuff.\n" ;

/***************************************************************************
 * ParseSync: parse and execute the sync ocmmand
 *
 * RETURNS: 0
 ***************************************************************************/

static int ParseSync (argc, argv)
    int  argc ;
    char **argv ;

{
/*
 * Decode rest of command line :
 */
    if ( argc == 1 )
    {
	/* Just one sync */
	KecConnectionDoSync (KecConn) ;
	return (0) ;
    } 
    else if ( (argc != 2) || (strcmp (argv[1], "true") && strcmp (argv[1], "false")) )
    {
	return (-1) ;
    }
    else
    {
	KecConnectionSync (KecConn, (*argv[1] == 't')) ;
	return (0) ;
    }
/* NOT REACHED */
}

/***************************************************************************
 * SyncInitialize: declare the sync command
 *
 * RETURNS: void.
 ***************************************************************************/

void SyncInitialize ()

{
    DeclareCommand ("sync"
		    , documentation
		    , ParseSync) ;
    return ;
}

