/* Copyright 1989-93 GROUPE BULL -- See license conditions in file COPYRIGHT */

/***************************************************************************
 * xtsample.c
 *
 * Hum...Long time since I have been writing an application. I hep I will 
 * cope with it quickly (using Athena widget set ?)
 ***************************************************************************/

#include <stdio.h>
#include <setjmp.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Command.h>

#include <KeServer.h>
#include <KesXt.h>

XtAppContext xt_app ;
jmp_buf      IceJmpBuf ;

/***************************************************************************
 * exit_cb
 * button_cb
 ***************************************************************************/

static void exit_cb (widget, unused1, unused2)
    Widget    widget ;
    XtPointer unused1 ;
    XtPointer unused2 ;

{
    fprintf (stderr, "Bye world.\n") ;
    exit (1) ;
}

static void button_cb (widget, text_ptr, unused)
    Widget    widget ;
    XtPointer text_ptr ;
    XtPointer unused ;
{
    fprintf (stderr, (char *) text_ptr) ;
    return ;
}

/***************************************************************************
 * main: creat the widget hierarchy and all the stuff
 ***************************************************************************/

main (argc, argv)
    int argc ;
    char **argv ;

{
    Widget toplevel, vpane, quit, buttonbox, widgets, resources ;
    unsigned char *value ;
    KesServer server ;

/*
 * Initialize Xt, create any widget hierarchy :
 */

    toplevel = XtAppInitialize (&xt_app
				, "Sample"
				, NULL, 0
				, &argc, argv
				, NULL, NULL
				, 0) ;

    vpane = XtVaCreateManagedWidget ("vpane"
				     , panedWidgetClass
				     , toplevel
				     , NULL) ;
    
    buttonbox = XtVaCreateManagedWidget ("buttonbox"
					 , boxWidgetClass
					 , vpane
					 , NULL) ;
    
    quit = XtVaCreateManagedWidget ("Quit"
				    , commandWidgetClass
				    , buttonbox
				    , XtNlabel, "QuitQuit"
				    , NULL) ;

    XtAddCallback (quit, XtNcallback
		   , exit_cb
		   , NULL) ;

    widgets = XtVaCreateManagedWidget ("button-1"
				    , commandWidgetClass
				    , buttonbox
				    , NULL) ;

    XtAddCallback (widgets, XtNcallback
		   , button_cb
		   , (XtPointer) "Button 1 Activated\n") ;

    resources = XtVaCreateManagedWidget ("button-2"
					 , commandWidgetClass
					 , buttonbox
					 , NULL ) ;

    XtAddCallback (resources, XtNcallback
		   , button_cb
		   , (XtPointer) "Button 2 Activated\n") ;

    XtRealizeWidget (toplevel) ;

/*
 * Now, plug the server to k-Edit:
 */

    if ( ! ( server = KesServerInitialize ("Sample") ) )
    {
	fprintf (stderr, "xtsample[main]: unable to initialize server.\n") ;
	exit (1) ;
    }

    if ( ! setjmp (IceJmpBuf) )
	KesXtServerPlug (xt_app, server, toplevel, IceJmpBuf) ;

    XtAppMainLoop (xt_app) ;
}
