/* Copyright 1989-93 GROUPE BULL -- See license conditions in file COPYRIGHT */

/***************************************************************************
 * xaw-help.c
 *
 * This is not really help, but displaying a file into a text widget in
 * read only mode.
 ***************************************************************************/

#include <stdio.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Cardinals.h>	

#include <X11/Shell.h>

#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Paned.h>

#include "xkedit.h"

static Widget TheHelper = (Widget) 0 ;
static Widget TheTexter = (Widget) 0 ;

/***************************************************************************
 * DisplayFile: display given file in a toplevel read-only shell
 *
 * RETURNS: void
 ***************************************************************************/

static void _DoClose (widget, unused1, unused2)
    Widget    widget ;
    XtPointer unused1 ;
    XtPointer unused2 ;

{
    XtDestroyWidget (TheHelper) ;
    TheHelper = (Widget) 0 ;
    TheTexter = (Widget) 0 ;
    return ;
}

void DisplayFile (ctxt, filename)
    Context ctxt ;
    char    *filename ;

{
    char   fullname[256] ;
    Widget widget, paned ;

/*
 * Create the toplevel help window if needed:
 */

    if ( ! TheHelper )
    {
	TheHelper = XtVaCreatePopupShell ("file-toplevel"
					  , topLevelShellWidgetClass
					  , ctxt->wtop
					  , XtNallowShellResize, TRUE
					  , XtNtransientFor, ctxt->wtop
					  , NULL) ;

	paned = XtCreateManagedWidget ("file-menubar"
				       , panedWidgetClass
				       , TheHelper
				       , NULL, ZERO) ;
	
	widget = XtCreateManagedWidget ("close"
					, commandWidgetClass
					, paned
					, NULL, ZERO) ;

	XtAddCallback (widget, XtNcallback, _DoClose, (XtPointer) 0) ;

	TheTexter = XtVaCreateManagedWidget ("file-viewer"
					     , asciiTextWidgetClass
					     , paned
					     , NULL, ZERO) ;

	XtRealizeWidget (TheHelper) ;
	XtPopup (TheHelper, XtGrabNone) ;
    }

/*
 * Display file in it:
 */

    sprintf (fullname, "%s/%s", Defaults.help_directory, filename);

    XtVaSetValues (TheTexter
		   , XtNtype, XawAsciiFile
		   , XtNstring, fullname
		   , NULL) ;

    return ;
}



    
