/* Copyright 1989-93 GROUPE BULL -- See license conditions in file COPYRIGHT */

/***************************************************************************
 * KeClientP.h
 *
 * this file contains private prototypes functions for K-edit client lib
 * to compile. It should never be included in a application programm 
 ***************************************************************************/

#ifndef _KE_CLIENT_P_H_
#define _KE_CLIENT_P_H_

extern int _IceKeditPoProtocolNumber ;

/*
 * Pending blocks: 
 *
 * Pending blocks are used to keep track of wich handler to invoke when
 * some reply arrives. This type should never be seen by programmers 
 */

typedef KePointer (*KecDecoder) (
#ifdef KEDIT_NeedsFunctionPrototype
      KecConnection kec_conn
    , char *pbuf			/* buffer to be decoded */
    , Bool swap				/* byte order */
#endif
) ;

typedef struct _KecPending {
    struct _KecPending	*next ;		/* list of pending requests */
    unsigned int 	serial ;	/* the serial of request */
    KecDecoder		decode ;	/* decoder function for reply */
    KecHandler		handler ;	/* to invoque on reply */
    KePointer    	closure ;	/* for previous callback */
} KecPendingRec ;


/* 
 * KCPend.c defines:
 */

KecPending _KecPendingMake (
#ifdef KEDIT_NeedsFunctionPrototype
      KecConnection kec			/* connection */
    , unsigned int  serial		/* serial waited for */
    , KecDecoder    decoder		/* decoder for the reply */
    , KecHandler    handler		/* handler for the reply */
    , KePointer     closure		/* handler's closure */
#endif
) ;

void _KecPendingFree (
#ifdef KEDIT_NeedsFUnctionPrototype
      KecConnnection kec		/* connection */
    , KecPending     pending		/* pending block to be deleted */
#endif
) ;

/* 
 * KCEvent.c defines:
 */

KeStatus _KecEventDecode (
#ifdef KEDIT_NeedsFunctionPrototype
      KecConnection kec_conn 
    , keditRequest *header		/* beginning of event specific data */
    , char     *body 			/* continuing event specific data */
    , KecEvent *event_ret		/* decoded event returned */
    , Bool     swap			/* swapped connection ? */
#endif
) ;

KeStatus _KecErrorDecode (
#ifdef KEDIT_NeedsFunctionPrototype
      KecConnection kec_conn		/* connection */
    , char *pbuf			/* beginning of error spcieific data */
    , KecError error_ret		/* decoded error returned */
    , Bool     swap			/* swapped connection ? */
#endif
) ;

void _KecDefaultErrorHandler (
#ifdef KEDIT_NeedsFunctionPrototype
      KecConnection kec			/* connection */
    , KecError      error		/* error */
#endif 
) ;

					     
void _KecDefaultEventHandler (
#ifdef KEDIT_NeedsFunctionPrototype
      KecConnection kec			/* connection */
    , KecEvent      event		/* event */
#endif 
) ;

void _KecDefaultIOErrorHandler (
#ifdef KEDIT_NeedsFunctionPrototype
      KecConnection kec			/* connection */
    , int errno				/* errno */
#endif
) ;

/*
 * KCIo.c
 */


KeStatus _KecWaitForReply (
#ifdef KEDIT_NeedsFunctionPrototype
      KecConnection kec 
    , unsigned int  serial 
#endif
) ;
    
#endif /* _KE_CLIENT_P_H_ */
