/* Copyright 1989-93 GROUPE BULL -- See license conditions in file COPYRIGHT */

/***************************************************************************
 * KesXtP.h
 *
 * Private defs for k-Edit interface to Xt
 ***************************************************************************/

#ifndef _KES_XT_P_H_
#define _KES_XT_P_H_

#include "KesXt.h"

/*
 * Some customizable flags:
 */

#define TYPEINFO_HASHTABLE_SIZE		256

/*
 * Fake resources data type:
 */

typedef KeStatus (*KesXtGetValue) (
#ifdef KEDIT_NeedsFunctionPrototype
      Widget            widget		/* widget to get from */
    , KesXtResourceInfo info		/* resource infos */
    , KePointer         *value_ret	/* returned pointer to value */
    , char		**errmsg_ret
    , KeErrorFreeFct	*errfree_ret 				   
#endif
) ;

#define KesXtNullGetValue	((KesXtGetValue) 0) 

typedef KeStatus (*KesXtSetValue) (
#ifdef KEDIT_NeedsFunctionPrototype
      Widget            widget		/* widget to set */
    , KesXtResourceInfo info		/* resource infos */
    , KePointer         value		/* pointer to new value */
    , char		**errmsg_ret
    , KeErrorFreeFct	*errfree_fct
#endif
) ;

#define KesXtNullSetValue	((KesXtSetValue) 0)

typedef KeStatus (*KesXtExec) (
#ifdef KEDIT_NeedsFunctionPrototype
      Widget            widget 
    , KesXtResourceInfo info 
    , char		**errmsg_ret
    , KeErrorFreeFct	*errfree_ret
#endif
) ;

#define KesXtNullExec		((KesXtExec) 0)

/*
 * This struct contains all the informations needed by k-Edit to reply
 * to protocol request on a given resource (either fake or real)
 */

typedef struct _KesXtResourceInfo {
    char		*name ;
    KeCodec		codec ;
    unsigned long 	mode ;
    unsigned long	mask ;
    KesXtGetValue       get ;
    KesXtSetValue       set ;
    KesXtExec           exec ;
} KesXtResourceInfoRec ;

/*
 * Internal prototypes:
 */

int _KesXtWidgetRealResourceCount (
#ifdef KEDIT_NeedsFunctionPrototype
      Widget widget
#endif
) ;

int _KesXtWidgetFakeResourceCount (
#ifdef KEDIT_NeedsFunctionPrototype
      Widget widget 
#endif
) ;

KeStatus _KesXtGetOneRealResource (
#ifdef KEDIT_NeedsFunctionPrototype
      Widget            widget
    , int               position
    , KesXtResourceInfo rinfo
#endif
) ;

KeStatus _KesXtGetOneFakeResource (
#ifdef KEDIT_NeedsFunctionPrototype
      Widget            widget
    , int               position
    , KesXtResourceInfo rinfo
#endif
) ;

int _KesXtFindChildren (
#ifdef KEDIT_NeedsFunctionPrototype
      Widget widget
    , Widget **children_ret
#endif
) ;

void KesXtResourceTypeInitialize (
#ifdef KEDIT_NeedsFunctionPrototype
      KesServer server
#endif
) ;
			 
KesHandlerSet KesWidgetHandlerSetGet () ;
KesHandlerSet KesResourceDirectoryHandlerSetGet() ;
KesHandlerSet KesResourceHandlerSetGet() ;

/*
 * Prototypes for exporting actions: define only if needed:
 */

#ifdef KESXT_EXPORT_ACTIONS

int _KesXtWidgetActionCount (
#ifdef KEDIT_NeedsFunctionPrototype
      Widget widget
#endif
) ;

KesHandlerSet KesActionDirectoryHandlerSetGet () ;

KesHandlerSet KesActionHandlerSetGet () ;

#endif /* KESXT_EXPORT_ACTIONS */

#endif /* _KES_XT_P_H_ */
