/* Copyright 1989-93 GROUPE BULL -- See license conditions in file COPYRIGHT */

/***************************************************************************
 * xt.c
 *
 * Various Xt hacks to get the info we need. Changes in Xt should be
 * located to this file only, if API can be preserved.
 * I can't remember the "inspiration" for this file, but I definetely
 * think it owes a lot to editres sources.
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <setjmp.h>

#include <KeServer.h>
#include <KesCodec.h>

#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>	/* for XtRString. */

#include <X11/ObjectP.h>	/* For XtIs<Classname> macros. */
#include <X11/ShellP.h>		/* for Application Shell Widget class. */

#include <X11/Xatom.h>
#include <X11/Xos.h>		/* for strcpy declaration */

#include "KesXtP.h"

/***************************************************************************
 * _KesXtFindChildren: find this widget children
 *
 * Caller should free the result of this function, using free.
 *
 * RETURN: children count, possibly 0
 ***************************************************************************/

int _KesXtFindChildren (widget, children_ret)
    Widget widget ;
    Widget **children_ret ;

{
    CompositeWidget composite = (CompositeWidget) widget;
    int             children_count = 0 ;
    int             i, current = 0;
    
    if ( XtIsWidget(widget) )
    {
	children_count += widget->core.num_popups ;
    }
	
    if ( XtIsComposite (widget) )
    {
	children_count += composite->composite.num_children ;
    }

    if ( ! children_count )
    {
	*children_ret = NULL; 
	return (0);
    }

    if ( *children_ret = (Widget *) malloc (sizeof (Widget) * children_count) )
    {
	if ( XtIsComposite(widget) )
	{
	    for (i = 0; i < composite->composite.num_children; i++,current++) 
		(*children_ret)[current] = composite->composite.children[i] ;
	}

	if ( XtIsWidget(widget) )
	{
	    for ( i = 0; i < widget->core.num_popups; i++, current++) 
		(*children_ret)[current] = widget->core.popup_list[i] ;
	}
    }

    return(children_count);
}

