/* Copyright 1989-93 GROUPE BULL -- See license conditions in file COPYRIGHT */

/***************************************************************************
 * KCExec.c
 *
 * Handle the A-sync version of exec
 ***************************************************************************/

#include <stdio.h>

#include <KeClient.h>
#include <KeClientP.h>

/***************************************************************************
 * KecExec: request to exec a node.
 *
 * RETURNS: keStatus (for the send op, not the hook done).
 ***************************************************************************/

KeStatus KecExec (kec, node)
    KecConnection kec ;
    KID node ;

{
    keditExecRequest *request ;
    KeStatus	     retval = KEDIT_Success ;
    char             *pdata ;

    KCLIENT_LOCK (kec) ;

    if ( kec->disconnected )
	return (KEDIT_Failure) ;

/*
 * Allocate the request in obuf, and set it
 */

    IceGetHeaderExtra (kec->ice_connection
		       , _IceKeditPoProtocolNumber
		       , KEDIT_Exec
		       , sizeof (keditRequest)
		       , (sizeof (keditExecRequest) - sizeof (keditRequest)) >> 3
		       , keditExecRequest
		       , request
		       , pdata) ;

    STORE_CARD32 (pdata, node) ;

    (kec->serial)++ ;

    KCLIENT_UNLOCK (kec) ;
    KCLIENT_SYNC (kec) ;
    return (retval) ;
}
