/* Copyright 1989-93 GROUPE BULL -- See license conditions in file COPYRIGHT */

/***************************************************************************
 * KCNotify.c
 *
 * Handle the synchronous version of the Notify request
 ***************************************************************************/

#include <stdio.h>

#include <KeClient.h>
#include <KeClientP.h>

/***************************************************************************
 * KecNotify: send a notify request (not waiting for reply)
 *
 * RETURNS: KeStatus (for the send op, not the hook done).
 ***************************************************************************/

KeStatus KecNotify (kec, node, mask)
    KecConnection kec;
    KID           node ;
    unsigned long mask ;

{
    keditNotifyRequest *request ;
    KeStatus           retval = KEDIT_Success ;
    char               *pdata ;

    KCLIENT_LOCK (kec) ;

    if ( kec->disconnected )
	return (KEDIT_Failure) ;

/*
 * Allocate the request in obuf, and set it
 */

    IceGetHeaderExtra (kec->ice_connection
		       , _IceKeditPoProtocolNumber
		       , KEDIT_Notify
		       , sizeof (keditRequest)
		       , (sizeof (keditNotifyRequest) - sizeof (keditRequest)) >> 3
		       , keditNotifyRequest
		       , request
		       , pdata) ;
    
    STORE_CARD32 (pdata, node) ;
    STORE_CARD16 (pdata, mask) ;

    (kec->serial)++ ;

    KCLIENT_UNLOCK (kec) ;
    KCLIENT_SYNC (kec) ;
    return (retval) ;
}
