/* Copyright 1989-93 GROUPE BULL -- See license conditions in file COPYRIGHT */

/***************************************************************************
 * KCSet.c
 *
 * Handle the A-sync version of K_Set
 ***************************************************************************/

#include <stdio.h>
#include <string.h>

#include <KeClient.h>
#include <KeClientP.h>

/***************************************************************************
 * K_Set: set a node value.
 *
 * Encode a Set request to output buffer
 *
 * RETURNS: KeStatus (for send op, not for ack of setting)
 ***************************************************************************/

KeStatus KecSet (kec, node, size, value)
    KecConnection kec ;
    KID           node ;
    unsigned int  size ;
    KePointer     value ;

{
    keditSetRequest *request ;
    KeStatus        retval = KEDIT_Success ;
    char            *pdata ;

    KCLIENT_LOCK (kec) ;

    if ( kec->disconnected )
	return (KEDIT_Failure) ;

/*
 * Compute full request size, and fill in the header :
 */

    IceGetHeaderExtra (kec->ice_connection
		       , _IceKeditPoProtocolNumber
		       , KEDIT_Set
		       , sizeof (keditRequest)
		       , (sizeof (keditSetRequest) - sizeof (keditRequest)) >> 3
		       , keditSetRequest
		       , request
		       , pdata) ;

    STORE_CARD32 (pdata, node) ;
    STORE_CARD32 (pdata, size) ;

    (kec->serial)++ ;

    if ( size ) {
	request->length += WORD64COUNT (size) ;
	IceWriteData (kec->ice_connection, size, value) ;
	IceWritePad  (kec->ice_connection, PAD64 (size)) ;
    }

    KCLIENT_UNLOCK (kec) ;
    KCLIENT_SYNC (kec) ;
    return (retval) ;
}




