/***************************************************************************
 * KCTFind.c
 *
 * Find a node given its path
 ***************************************************************************/

#include <stdio.h>

#include <KeClient.h>

#define KCACHE_SIZE	16

static KecConnection theConnection         = (KecConnection) 0 ;
static char	     *thePath[KCACHE_SIZE] = { (char *) 0, } ;
static KID           theIds[KCACHE_SIZE]   = { (KID) -1, } ;
static int           theCached             = 0 ;

/***************************************************************************
 * KecFind: retreive a node given its name
 *
 * Maintains a cache on last search.
 ***************************************************************************/

KID KecFind (kconn, kid, path, npath)
    KecConnection kconn ;
    KID           kid ;
    char	  **path ;
    int           npath ;

{
    int i, np = 0, count ;
    KeNodeStat *stats ;
    
    for ( i = 0 ; i < theCached ; i++ ) {
	if ( theIds[i] == kid )
	    break ;
    }
    if ( theIds[i] == kid ) {
	while ( (i < theCached) && (np < npath) ) {
	    if ( strcmp (thePath[i], path[np]) )
		break ;
	    i++ ; np++ ;
	}
    } else {
	i = 0 ;
    }

    while ( np < npath ) {
	if ( (count = KecLsl (kconn, kid, &stats)) <= 0 )
	    return ((KID) -1) ;
	while ( --count >= 0 ) {
	    if ( ! strcmp (path[np], stats[count]->name) ) {
		kid = theIds[i] = stats[count]->id ;
		if ( thePath[i] ) free (thePath[i]) ;
		thePath[i++] = (char *) strdup (stats[count]->name) ;
		break ;
	    }
	}
	KecLslFree (stats) ;
	np++ ;
    }
    theCached     = i ;
    theConnection = kconn ;
    return (kid) ;
}

