/***************************************************************************
 * KeNS
 *
 * k-Edit name server definitions.
 ***************************************************************************/

#ifndef _KENS_H_
#define _KENS_H_

#include <KeServer.h>
#include <KeClient.h>
#include <KeCodec.h>

#define KNS_DEFAULT_ADRESS	"tcp/localhost:2000"

typedef struct _KnsProperty {
    KeCodec	codec ;
    char	*name ;
    union {
	BYTE   byte ;
	CARD16 card16 ;
	CARD32 card32 ;
	char   *string ;
    } val ;
} KnsPropertyRec, *KnsProperty ;
    
typedef struct _KnsServer {
    char	*name ;
    KID		node ;
/*
 * Rest of properties:
 */
    int         propertiesC ;
    int         propertiesS ;
    KnsProperty *properties ;		/* list of properties */
/*
 * If i'm the owner of this server, than this points to propertor
 */
    KID		propertor_name ;
    KID		propertor_type ;
} KnsServerRec, *KnsServer ;

typedef struct _KnsData {	/* User data attached to NS connection */
    KID		server_dir ;		/* directory of servers node id */
    KecNotifyId server_notify ;		/* on Create/Delete of servers */
    int		serversS ;
    int		serversC ;
    KnsServer	*servers ;		/* found server */
    KID		servor_name ;
    KID		servor_adress ;
    KID		servor_protocol ;
    KID		servor_description ;
} KnsDataRec, *KnsData ;

#define KNS_CONNDATA(c)	((KnsData) KecGetUserDataOfConnection (c))

/*
 * Prototype
 */

KecConnection KnsOpen (
#ifdef KEDIT_NeedsFunctionPrototype
      char *name
#endif
) ;

int KnsServerEnumerate (
#ifdef KEDIT_NeedsFUnctionPrototype
      KecConnection kconn
    , KnsServer     **servers_ret
#endif
) ;

int KnsServerPropertiesEnumerate (
#ifdef KEDIT_NeedsFunctionPrototype
      KecConnection kconn
    , KnsServer     server
    , KnsProperty   **props_ret 
#endif
) ;

KnsServer KnsDeclareServer (
#ifdef KEDIT_NeedsFunctionPrototype
      KecConnection kns
    , char *name
    , char *adress
    , char *protocol
    , char *description
#endif
) ;

KnsProperty KnsDeclareServerProperty (
#ifdef KEDIT_NeedsFunctionPrototype
      KecConnection kns
    , KnsServer     server
    , char	    *name
    , KID	    type
    , KePointer     ival
#endif
) ;				      
#endif /* _KENS_H_ */
