/***************************************************************************
 * client.c
 *
 * Client API for name server query
 ***************************************************************************/

#include <stdio.h>
#include <KeNS.h>

int KnsServerEnumerate (kconn, servers_ret)
    KecConnection kconn ;
    KnsServer     **servers_ret ;
{
    KnsData knsd = KNS_CONNDATA(kconn) ;

    *servers_ret = knsd->servers ;
    return (knsd->serversC) ;
}

static KnsProperty buildProperty (kconn, kstat)
    KecConnection kconn ;
    KeNodeStat    kstat ;
{
    KnsProperty prop = (KnsProperty) malloc (sizeof (KnsPropertyRec)) ;

    if ( ! prop )
	return (prop) ;
    prop->name  = (char *) strdup (kstat->name) ;
    prop->codec = KecNodeCodec (kconn, kstat->id) ;
    bzero (&(prop->val), sizeof (prop->val)) ;
    if ( kstat->size  > 0 )
	KecGetDecode (kconn,kstat->id,prop->codec,(KePointer*)&(prop->val)) ;
    return (prop) ;
}

int KnsServerPropertiesEnumerate (kconn, server, props_ret)
    KecConnection kconn ;
    KnsServer     server ;
    KnsProperty   **props_ret ;
{
    KnsData    kns = KNS_CONNDATA (kconn) ;
    KeNodeStat  *stats ;
    int         count ;
    KnsProperty *p ;
    
    if ( server->properties ) {
	*props_ret = server->properties ;
	return (server->propertiesC) ;
    }
    if ( (count = KecLsl (kconn, server->node, &stats)) < 0 )
	return (-1) ;
    server->properties = (KnsProperty*) malloc (sizeof (KnsProperty*) * count);
    if ( ! server->properties )  {
	KecLslFree (stats) ;
	return (-1) ;
    }
    server->propertiesS = count ;
    for (p = server->properties ; count-- ; ) {
	if ( ( ! strcmp (stats[count]->name, "*servor*"))
	    || ( ! strcmp (stats[count]->name, "*propertor*")) ) {
	    continue ;
	} else if ( ! ( *p++ = buildProperty (kconn, stats[count]) ) ) {
	    KecLslFree (stats) ;
	    free (server->properties) ;
	    server->properties = (KnsProperty *) 0 ;
	}
    }
    KecConnectionDoSync (kconn) ;
    server->propertiesC = p - server->properties ;
    *props_ret = server->properties  ;
    return (server->propertiesC) ;
}

KnsServer KnsServerLookup ()

{}

