/***************************************************************************
 * dtst.c
 *
 * Kns library test
 ***************************************************************************/


#include <stdio.h>

#include <KeNS.h>


static KecConnection theKns = (KecConnection ) 0 ;
static char          *theKnsName = (char *) 0 ;
static KnsServer theServer ;

/*
 * Print 
 */

static void printProperty (prop)
    KnsProperty prop ;

{
    if ( prop->codec == KeCodecSTRINGGet() ) {
	printf ("\t%s=%s\n", prop->name, prop->val.string) ;
    } else if ( prop->codec == KeCodecCARD32Get() ) {
	printf ("\t%s=%d\n", prop->name, prop->val.card32) ;
    } else if ( prop->codec == KeCodecCARD16Get() ) {
	printf ("\t%s=%d\n", prop->name, prop->val.card16) ;
    } else if ( prop->codec == KeCodecBYTEGet() ) {
	printf ("\t%s=x%02x\n", prop->name, prop->val.byte) ;
    } else {
	printf ("\t%s=<not decoder for value>\n") ;
    }
    return ;
}
		   
static void printServer (fullp, server)
    int       fullp ;
    KnsServer server ;

{
    int         count ;
    KnsProperty *props ;
    
    printf ("%s\n", server->name) ;
    if ( (count = KnsServerPropertiesEnumerate (theKns, server, &props)) < 0){
	printf ("\t*** Unable to get properties.\n") ;
	return ;
    }
    while ( count-- ) {
	printProperty (props[count]) ;
    }
    return ;
}

/*
 * List available servers
 */

void ListServers (fullp)
    int fullp ;

{
    KnsServer *servers ;
    int       count = KnsServerEnumerate (theKns, &servers) ;

    while ( count-- > 0 ) {
	if ( ! strcmp (servers[count]->name, "xmh") )
	    theServer = servers[count] ;
	printServer (fullp, servers[count]) ;
    }
    return ;
}

main (argc, argv)
    int  argc ;
    char **argv ;

{
    argc-- ;
    argv++ ;
    while ( argc >  0 ) {
	if ( argc && ! strcmp ("-name", *argv) ) {
	    theKnsName = *++argv ;
	    argc -= 2 ;
	} else {
	    fprintf (stderr, "Usage: ctst -name <kns coordinates>\n") ;
	    exit (1) ;
	}
    }
    if ( ! ( theKns = KnsOpen (theKnsName)) ) {
	fprintf (stderr, "ctst: unable to open %s\n", theKnsName) ;
	exit (1) ;
    }
    ListServers (1) ;
    exit (0) ;
}
