/***************************************************************************
 * server.c
 *
 * Server API for name server registration
 ***************************************************************************/

#include <stdio.h>
#include <KeNS.h>

KnsServer KnsDeclareServer (kns, name, adr, prot, descr)
    KecConnection kns ;
    char *name, *adr, *prot, *descr ;

{
    KnsData  knsd = KNS_CONNDATA(kns) ;
    int      i ;
    KeStatus s ;

    s = KecSetEncode (kns,knsd->servor_name,KeCodecSTRINGGet(),name) ;
    if ( s ) return ((KnsServer) 0) ;
    s = KecSetEncode (kns,knsd->servor_adress,KeCodecSTRINGGet(),adr) ;
    if ( s ) return ((KnsServer) 0) ;
    s = KecSetEncode (kns,knsd->servor_protocol,KeCodecSTRINGGet(),prot) ;
    if ( s ) return ((KnsServer) 0) ;
    s = KecSetEncode (kns,knsd->servor_description,KeCodecSTRINGGet(),descr);
    if ( s ) return ((KnsServer) 0) ;
    s = KecExec (kns, knsd->servor_name) ;
    KecConnectionDoSync (kns) ;
    /* At this time, we should have created the corresponding server */
    for (i = 0 ; i < knsd->serversC ; i++ ) {
	if ( ! strcmp (knsd->servers[i]->name, name) )
	    return (knsd->servers[i]) ;
    }
    return ((KnsServer) 0) ;
}

KnsProperty KnsDeclareServerProperty (kns, server, name, type, init)
    KecConnection kns ;
    KnsServer     server ;
    char          *name ;
    KID           type ;
    KePointer     init ;

{
    KnsData  knsd = KNS_CONNDATA (kns) ;
    KeStatus s ;

    if ((server->propertor_name==(KID)-1) || (server->propertor_type==(KID)-1))
	return (KEDIT_InvalidOp) ;
    s = KecSetEncode (kns, server->propertor_name, KeCodecSTRINGGet(), name) ;
    if ( s ) return (s) ;
    s = KecSetEncode (kns, server->propertor_type, KeCodecCARD32Get(), &type) ;
    if ( s ) return (s) ;
    s = KecExec (kns, server->propertor_name) ;
    KecConnectionDoSync (kns) ;
    return ((KnsProperty) 0) ;
}

