/***************************************************************************
 * stst.c
 ***************************************************************************/

#include <stdio.h>

#include <KeServer.h>
#include <KeClient.h>
#include <KeNS.h>

static KecConnection theKns ;
static KesServer     theServer ;
static char *theKnsName = (char *) 0 ;
static KnsServer theMyself ;

main (argc, argv)
    int  argc ;
    char **argv ;

{
    argc-- ;
    argv++ ;
    while ( argc > 0 ) {
	if ( argc && ! strcmp (*argv, "-name") ) {
	    theKnsName = *++argv ;
	    argc -= 2 ;
	} else {
	    fprintf (stderr, "Usage: stst -name <kns coordinates>\n") ;
	    exit (1) ;
	}
    }
    
    if ( ! ( theKns = KnsOpen (theKnsName) ) ) {
	fprintf (stderr, "Unable to open <%s>\n", theKnsName) ;
	exit (1) ;
    }
    if ( ! ( theServer = KesServerInitialize ("kns-test_server")) ) {
	fprintf (stderr, "Unable to initialize as k-Edit server.\n") ;
	exit (1) ;
    }

    if (!(theMyself = KnsDeclareServer (theKns
					, "kns-test_server" 
					, "tcp/localhost:2001"
					, "k-Edit.2" 
					, "Sample test server for kns"))) {
	fprintf (stderr, "Unable to register myself.\n") ;
	exit (1) ;
    }
    
    KnsDeclareServerProperty (theKns /* KnsOpen return value */
			      , theMyself /* server on which we want to add a perty for  */
			      , "location" /* property name */
			      , KecNamedCodecGet (theKns, "STRING") /* its type */
			      , (KePointer) 0) ; /* its value */
			      
    IceMainLoop (theServer) ;
}
