/***************************************************************************
 * kns.h
 ***************************************************************************/

#ifndef _KNS_H_
#define _KNS_H_

#define PROP_OMODE   (KEDIT_ReadMode | KEDIT_WriteMode)
#define PROP_MODE    (KEDIT_ReadMode)
#define PROP_MASK    (KEDIT_WriteMask | KEDIT_WriteWithValueMask)

typedef struct _Server   *Server ;
typedef struct _Property *Property ;
typedef struct _Propertor *Propertor ;

typedef struct _Server {
    Server       next ;
    KesDirectory dir ;
    KesClient    owner ;
    KesStruct    propertor, servor ;
} ServerRec ;

typedef struct _Property {
    Server        server ;
    KID		  node ;
    char	  *name ;
    unsigned long mask ;
    KeCodec	  codec ;
    KePointer	  value ;
    unsigned int  size ;
} PropertyRec ;

typedef struct _Propertor {
    Server server ;
    char   *name ;
    KID    type ;
} PropertorRec ;

typedef struct _Servor {
    Server server ;
    char   *name ;
    char   *adress ;
    char   *protocol ;
    char   *description ;
} ServorRec, *Servor ;

#define PropOwner(r,p)	(KesClientOfRequest(r) == p->server->owner)


#ifndef _MAIN_

extern KesServer theKNS ;

#endif /* _MAIN_ */

/* Proto */

#define P(x)	x

void       *SafeMalloc P ((unsigned int size)) ;
Property   DeclareProperty P ((Server s, char *n, KeCodec z, KePointer init));
Server     DeclareServer P ((KesClient c,char *n, char *a, char *p, char *d));
    
KesStruct  PropertorMake P((Server server)) ;
void       PropertorInitialize P ((void)) ;

KesStruct  ServorMake P((Server server)) ;
void ServorInitialize P ((void)) ;
			    
#endif /* _KNS_H_ */
