/***************************************************************************
 * propertor.c
 *
 * Propertor are server's prototype to build new property (register them)
 ***************************************************************************/

#include <stdio.h>

#include <KeServer.h>
#include <KeStruct.h>

#include "kns.h"

static KesStructClass thePropertorClass ;

KesStruct PropertorMake (server)
    Server server ;

{
    Propertor propertor = (Propertor) SafeMalloc (sizeof(PropertorRec)) ;
    propertor->name   = (char *) 0 ;
    propertor->type   = (KID) -1 ;
    propertor->server = server ;
    return (KesStructMake (theKNS
			   , thePropertorClass
			   , "*propertor*"
			   , (KePointer) propertor
			   , (unsigned long) 0)) ;
}

void PropertorDelete (propertor_struct)
    KesStruct propertor_struct ;
    
{
    Propertor propertor = (Propertor) propertor_struct->pointer ;
    
    KesStructDelete (propertor_struct) ;
    if ( propertor->name )
	free (propertor->name) ;
    free (propertor) ;
    return ;
}

static KeStatus propertorExec (obj, accessor, emsg, efree)
    KesStruct         obj ;
    KesStructAccessor accessor ;
    char              **emsg ;
    KeErrorFreeFct    *efree ;

{
    Propertor propertor = (Propertor) obj->pointer ;

    if ( propertor->name && KesCodecFind (obj->server, propertor->type) ) {
	DeclareProperty (propertor->server
			 , propertor->name
			 , KesCodecFind (obj->server, propertor->type)
			 , (KePointer) 0) ;
    } else {
	*emsg  = "Invalid parameters." ;
	*efree = (KeErrorFreeFct) 0 ;
    }
    return (KEDIT_Success) ;
}

void PropertorInitialize ()

{
    thePropertorClass = KesStructClassMake ("Propertor") ;
    KesStructAccessorDeclare (thePropertorClass
			      , "name"
			      , ( KEDIT_WriteMode
				 | KEDIT_ReadMode
				 | KEDIT_ExecMode )
			      , (unsigned long) 0
			      , KesOffsetOf (PropertorRec, name)
			      , KeCodecSTRINGGet ()
			      , KesStructStringSet
			      , KesStructStringGet
			      , propertorExec) ;
    KesStructAccessorDeclare (thePropertorClass
			      , "type"
			      , ( KEDIT_WriteMode
				 | KEDIT_ReadMode
				 | KEDIT_ExecMode )
			      , (unsigned long) 0
			      , KesOffsetOf (PropertorRec, type)
			      , KeCodecCARD32Get ()
			      , KesStructNullSlotSet
			      , KesStructNullSlotGet
			      , propertorExec) ;
    return ;
}
