/***************************************************************************
 * servor.c
 *
 * The prototype to build (register) new servers.
 ***************************************************************************/

#include <stdio.h>

#include <KeServer.h>
#include <KeStruct.h>

#include "kns.h"

static KesStructClass theServorClass ;

KesStruct ServorMake (server)
    Server server ;

{
    Servor servor  = (Servor) SafeMalloc (sizeof (ServorRec)) ;
    servor->name   = (char *) 0 ;
    servor->server = (Server) 0 ;
    return (KesStructMake (theKNS
			   , theServorClass
			   , "*servor*"
			   , (KePointer) servor
			   , (unsigned long) 0)) ;
}

void ServorDelete (servor_struct)
    KesStruct servor_struct ;
{
    Servor servor = (Servor) servor_struct->pointer ;

    KesStructDelete (servor_struct) ;
    if ( servor->name )
	free (servor->name) ;
    free (servor) ;
    return ;
}

static KeStatus servorExec (obj, accessor, emsg, efree)
    KesStruct obj ;
    KesStructAccessor accessor ;
    char **emsg ;
    KeErrorFreeFct *efree ;
{
    Servor servor = (Servor) obj->pointer ;
    
    if (servor->name
	&& servor->adress && servor->protocol && servor->description) {
	/* Should check server by accessing it here */
	DeclareServer (KesClientOfRequest(KesStructCurrentRequest())
		       , servor->name
		       , servor->adress
		       , servor->protocol
		       , servor->description) ;
	return (KEDIT_Success) ;
    } else {
	*emsg  = "Invalid parameters to register server." ;
	*efree = (KeErrorFreeFct) 0 ;
	return (KEDIT_Failure) ;
    }
}

void ServorInitialize ()

{
    theServorClass = KesStructClassMake ("Servor") ;
    KesStructAccessorDeclare (theServorClass
			      , "name"
			      , KEDIT_ReadMode|KEDIT_WriteMode|KEDIT_ExecMode
			      , (unsigned long) 0
			      , KesOffsetOf (ServorRec, name)
			      , KeCodecSTRINGGet()
			      , KesStructStringSet
			      , KesStructStringGet
			      , servorExec) ;
    KesStructAccessorDeclare (theServorClass
			      , "adress"
			      , KEDIT_ReadMode|KEDIT_WriteMode|KEDIT_ExecMode
			      , (unsigned long) 0
			      , KesOffsetOf (ServorRec, adress)
			      , KeCodecSTRINGGet()
			      , KesStructStringSet
			      , KesStructStringGet
			      , servorExec) ;
    KesStructAccessorDeclare (theServorClass
			      , "protocol"
			      , KEDIT_ReadMode|KEDIT_WriteMode|KEDIT_ExecMode
			      , (unsigned long) 0
			      , KesOffsetOf (ServorRec, protocol)
			      , KeCodecSTRINGGet()
			      , KesStructStringSet
			      , KesStructStringGet
			      , servorExec) ;
    KesStructAccessorDeclare (theServorClass
			      , "description"
			      , KEDIT_ReadMode|KEDIT_WriteMode|KEDIT_ExecMode
			      , (unsigned long) 0
			      , KesOffsetOf (ServorRec, description)
			      , KeCodecSTRINGGet()
			      , KesStructStringSet
			      , KesStructStringGet
			      , servorExec) ;

    return ;
}
