/***************************************************************************
 * main.c
 * A simple xaw mpeg player, hacked quickly.
 ***************************************************************************/

#include <stdio.h>
#include <setjmp.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Cardinals.h>	

#include <X11/Xaw/Box.h>	
#include <X11/Xaw/Paned.h>	
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Toggle.h>

#include <KeServer.h>
#include <KesXt.h>
#include <KeStruct.h>

#include <mpegdec.h>
#include <yccX.h>

/*
 * I have been using too much scheme, and I fed up of defining types
 * for all callbacks...
 */

static XtAppContext     xtapp ;
static Widget           CtrlPrev, CtrlNext, VideoScreen, CtrlPlay, CtrlDir ;
static MpegIStream      VideoStream ;
static MpegAttributes   VideoAttr ;
static XtIntervalId     XtTick    = (XtIntervalId) 0 ;
static unsigned long    VideoRate = (unsigned long) 20 ;
static XImage           *VideoImage ;
static Pixmap           VideoPixmap ;
static GC               VideoGc ;
static YCCDitherContext VideoDc ;
static Colormap 	VideoColormap ;
static char             *FilmName ;
static int              VideoDirection = 1 ;
static Boolean		VideoState = (Boolean) 0 ;


static void StartVideo () ;
static void PauseVideo () ;
static void VideoNext () ;
static void VideoPrev () ;
    
/***************************************************************************
 * k-Edit stuff
 ***************************************************************************/

typedef struct _KeState {
    unsigned char	state ;
    unsigned char	next, prev ;
    unsigned char 	dir ;
} KeStateRec, *KeState ;

KeStateRec NetState = {
    (unsigned char) 0,				/* suspended */
    (unsigned char) 0, (unsigned char) 0,	/* next, prev unused */
    (unsigned char) 1				/* forward */
} ;

static KesStruct NetStateStruct ;

static KesStructAccessor StateAccessor ;
static KesStructAccessor DirAccessor ;
static KesStructAccessor NextAccessor ;
static KesStructAccessor PrevAccessor ;

static KeStatus stateSet (object, accessor, value, msg_ret, free_ret)
    KesStruct         object ;
    KesStructAccessor accessor ;
    KePointer         value ;
    char              **msg_ret ;
    KeErrorFreeFct    *free_ret ;
{
    unsigned char *ploc ;
    unsigned char val = *((unsigned char *) value) ;
    ploc = ((unsigned char *) object->pointer) + accessor->offset ;
    if ( val && ( ! VideoState ) ) {		/* resume video */
        StartVideo () ;
    } else if ( ( ! val) && VideoState) {	/* suspend video */
        PauseVideo () ;
    }
    return (KEDIT_Success) ;
}

static KeStatus dirSet (object, accessor, value, msg_ret, free_ret)
    KesStruct         object ;
    KesStructAccessor accessor ;
    KePointer         value ;
    char              **msg_ret ;
    KeErrorFreeFct    *free_ret ;
{
    unsigned char *ploc ;
    unsigned char val = *((unsigned char *) value) ;
    ploc = ((unsigned char *) object->pointer) + accessor->offset ;
    if ( (val == (unsigned char) 0) && ( VideoDirection == 2 ) ) {
        VideoDir (1) ;
    } else if ( (val == (unsigned char) 1) && (VideoDirection == 1) ) {
        VideoDir (2) ;
    } else if ( ((int) *ploc) != NetState.dir ) {
        *msg_ret  = "Invalid direction (should be 0 or 1)" ;
        *free_ret = (KeErrorFreeFct) 0 ;
        return (KEDIT_InvalidData) ;
    }
    *ploc = *((unsigned char *) value) ;
    return (KEDIT_Success) ;
}

static KeStatus prevExec (object, accessor, msg_ret, free_ret)
    KesStruct object ;
    KesStructAccessor accessor ;
    char **msg_ret ;
    KeErrorFreeFct *free_ret ;
{
    if ( VideoState ) {
        *msg_ret  = "Cannot prev frame while running." ;
        *free_ret = (KeErrorFreeFct) 0 ;
        return (KEDIT_Failure) ;
    } else {
        VideoPrev () ;
        return (KEDIT_Success) ;
    }
    /* NOT REACHED */
}

static KeStatus nextExec (object, accessor, msg_ret, free_ret)
    KesStruct object ;
    KesStructAccessor accessor ;
    char **msg_ret ;
    KeErrorFreeFct *free_ret ;
{
    if ( VideoState ) {
        *msg_ret  = "Cannot next frame while running." ;
        *free_ret = (KeErrorFreeFct) 0 ;
        return (KEDIT_Failure) ;
    } else {
        VideoNext () ;
        return (KEDIT_Success) ;
    }
}

void KeditInitialize (server)
    KesServer server ;
{
    KesStructClass KeStateClass ;
/*
 * Declare our state struct to k-Edit:
 */
    KeStateClass = KesStructClassMake ("video-state") ;
    KesStructAccessorDeclare (KeStateClass
                              , "state"
                              , KEDIT_ReadMode | KEDIT_WriteMode
                              , KEDIT_WriteMask | KEDIT_WriteWithValueMask
                              , KesOffsetOf (KeStateRec, state)
                              , KeCodecBYTEGet()
                              , stateSet
                              , KesStructNullSlotGet
                              , KesStructNullSlotExec) ;
    KesStructAccessorDeclare (KeStateClass
                              , "dir"
                              , KEDIT_ReadMode | KEDIT_WriteMode
                              , KEDIT_WriteMask | KEDIT_WriteWithValueMask
                              , KesOffsetOf (KeStateRec, dir)
                              , KeCodecBYTEGet()
                              , dirSet
                              , KesStructNullSlotGet
                              , KesStructNullSlotExec) ;
    KesStructAccessorDeclare (KeStateClass
                              , "prev"
                              , KEDIT_ExecMode
                              , KEDIT_ExecMask
                              , KesOffsetOf (KeStateRec, prev)
                              , KeCodecBYTEGet()
                              , KesStructNullSlotSet
                              , KesStructNullSlotGet
                              , prevExec) ;
    KesStructAccessorDeclare (KeStateClass
                              , "next"
                              , KEDIT_ExecMode
                              , KEDIT_ExecMask
                              , KesOffsetOf (KeStateRec, next)
                              , KeCodecBYTEGet()
                              , KesStructNullSlotSet
                              , KesStructNullSlotGet
                              , nextExec) ;
/*
 * Find back created accessors:
 */
    StateAccessor = KesStructClassAccessorFind (KeStateClass, "state") ;
    DirAccessor   = KesStructClassAccessorFind (KeStateClass, "dir") ;
    PrevAccessor  = KesStructClassAccessorFind (KeStateClass, "prev") ;
    NextAccessor  = KesStructClassAccessorFind (KeStateClass, "next") ;
    
/*
 * Export our initial state:
 */
    NetStateStruct = KesStructMake (server
                                    , KeStateClass
                                    , "*state*"
                                    , (KePointer) &NetState
                                    , 0) ;
    KesDirectoryAddChild (KesRootDirectoryOfServer (server)
                          , NetStateStruct->node) ;
    return ;
}

/***************************************************************************
 * Mpeg interface
 ***************************************************************************/

/* Create the video stream , gievn the source file.
 * Also sets upthe globals:
 * - VideoAttr
 * - VideoImage
 * - VideoGc
 * - VideoDc
 * - VideoStream
 */

static MpegIStream MakeVideoStream (display, filename)
    Display *display ;
    char    *filename ;
{
    MpegIStream          vs ;
    MpegConfigAttributes attr ;
    unsigned char        *buffer ;
    int                  ditherType, depth ;
    double               gamma = 1.0 ;
    int                  screen = DefaultScreen (display) ;
    XGCValues            gc_values ;
    
/* Open video stream */
    if ( ! (attr.input = fopen (filename, "r")) ) {
        fprintf (stderr, "Cannot open file %s for reading.\n", filename) ;
        exit (1) ;
    }
    if ( ! (vs = mpegNewStream (0)) ) {
        fprintf (stderr, "Cannot mpegNewStream(0).\n") ;
        exit (1) ;
    } 
    attr.No_B_Flag    = 0 ;
    attr.No_P_Flag    = 0 ;
    attr.positionFlag = 1 ;
    mpegConfigure (vs, &attr) ;
    if ( mpegInitStream (vs) ) {
        fprintf (stderr, "Cannot mpegInitStream.\n") ;
        exit (1) ;
    }
/* Get VideoAttr */
    if ( mpegGetAttributes (vs, &VideoAttr) ) {
        fprintf (stderr, "Cannot mpegGetAttributes.\n") ;
        exit (1) ;
    }
/* Create the right VideoImage */
    depth = DefaultDepth (display, screen) ;
    if ( depth == 8 ) {
        ditherType = PseudoColorDither ;
    } else if ( depth == 32 ) {
        ditherType = TrueColorDither ;
    } else {
        fprintf (stderr, "No suitable visual.\n") ;
        exit (1) ;
    }
    VideoColormap = DefaultColormap (display, screen) ;
    VideoDc = yccCreateDC (ditherType
                           , display
                           , DefaultVisual (display, screen)
                           , screen
                           , &VideoColormap 
                           , gamma, gamma, gamma, gamma, 0) ;
    buffer = (unsigned char *)malloc(VideoAttr.width*VideoAttr.height*depth/8);
    VideoImage = XCreateImage (display
                               , DefaultVisual (display, screen)
                               , depth
                               , ZPixmap, 0
                               , buffer
                               , VideoAttr.width, VideoAttr.height
                               , depth, 0) ;
    VideoImage->byte_order = MSBFirst ;
/* Create the VideoPixmap */
    VideoPixmap = XCreatePixmap (display
                                 , DefaultRootWindow (display)
                                 , VideoAttr.width
                                 , VideoAttr.height
                                 , depth) ;
/* Create the VideoGc */
    gc_values.foreground     = BlackPixel (display, screen) ;
    gc_values.background     = WhitePixel (display, screen) ;
    gc_values.subwindow_mode = IncludeInferiors ;
    VideoGc = XCreateGC (display
                         , VideoPixmap
                         , GCForeground | GCBackground | GCSubwindowMode
                         , &gc_values) ;
    VideoStream = vs ;
    return (vs) ;
}

/* All video functions uses the global VideoStream and xtapp to perform
 * their job */

static void displayNextFrame (whatp, ptimer)
    XtPointer    whatp ;	/* bits: 4=rearm 2=prev 1=fwd */
    XtIntervalId *ptimer ;
{
    int what  = (int) whatp ;
    int error ;

    XtTick = (XtIntervalId) 0 ;
    if ( what & 1 ) {
        error = mpegDecodeNext (VideoStream) ;
    } else if ( what & 2 ) {
        error = mpegDecodePrevious (VideoStream) ;
    }
        
    if ( error == V_END_SEQUENCE ) {	/* enforce a pause */
        PauseVideo () ;
    } else {				/* continue */
        yccDither (VideoDc
                   , VideoAttr.width, VideoAttr.height
                   , VideoImage->data
                   , MPEG_CUR_LUM(VideoStream)
                   , MPEG_CUR_CR (VideoStream)
                   , MPEG_CUR_CB (VideoStream)) ;
        XPutImage (XtDisplay (VideoScreen)
                   , VideoPixmap
                   , VideoGc
                   , VideoImage
                   , 0, 0, 0, 0
                   , VideoImage->width
                   , VideoImage->height) ;
        XClearWindow (XtDisplay (VideoScreen), XtWindow (VideoScreen)) ;
        if ( what & 4 ) {
            XtTick = XtAppAddTimeOut (xtapp
                                      , VideoRate
                                      , displayNextFrame
                                      , (XtPointer) (4|VideoDirection)) ;
        } else {
            if ( what & 2 ) 
                XtVaSetValues (CtrlNext, XtNsensitive, (Boolean) 1, NULL) ;
            else /* what & 1 */
                XtVaSetValues (CtrlPrev, XtNsensitive, (Boolean) 1, NULL) ;
        }
    }
    return ;
}

static void StartVideo ()
{
    displayNextFrame ((XtPointer) (4 | VideoDirection), (XtIntervalId *) 0) ;
    if ( XtTick ) {
        VideoState     = (Boolean) 1 ;
        if ( ! NetState.state ) {
            NetState.state = (unsigned char) 1 ;
            KesStructSlotNotify (NetStateStruct
                                 , (unsigned long) 0
                                 , StateAccessor
                                 , KEDIT_WriteWithValueMask) ;
        }
        XtVaSetValues (CtrlPrev, XtNsensitive, (Boolean) 0, NULL) ;
        XtVaSetValues (CtrlNext, XtNsensitive, (Boolean) 0, NULL) ;
        XtVaSetValues (CtrlPlay, XtNlabel, "pause", NULL) ;
    }
    return ;
}

static void PauseVideo () 
{
    if ( XtTick ) {
        XtRemoveTimeOut (XtTick) ;
        XtTick = (XtIntervalId) 0 ;
    }
    if ( NetState.state ) {
        NetState.state = (unsigned char) 0 ;
        KesStructSlotNotify (NetStateStruct
                             , (unsigned long) 0
                             , StateAccessor
                             , KEDIT_WriteWithValueMask) ;
    }
    VideoState     = (Boolean) 0 ;
    XtVaSetValues (CtrlPrev, XtNsensitive, (Boolean) 1, NULL) ;
    XtVaSetValues (CtrlNext, XtNsensitive, (Boolean) 1, NULL) ;
    XtVaSetValues (CtrlPlay, XtNlabel, "play", NULL) ;
    return ;
}

static void VideoNext ()
{
    displayNextFrame (1, (XtIntervalId *) 0) ;
    KesStructSlotNotify (NetStateStruct
                         , (unsigned long) 0
                         , NextAccessor
                         , KEDIT_ExecMask) ;
    return ;
}

static void VideoPrev () 
{
    displayNextFrame (2, (XtIntervalId *) 0) ;
    KesStructSlotNotify (NetStateStruct
                         , (unsigned long) 0
                         , PrevAccessor
                         , KEDIT_ExecMask) ;
    return ;
}

static void VideoDir (fwd_p)
    int fwd_p ;
{
    if ( (fwd_p == 2) && (VideoDirection == 1)) {
        VideoDirection = 2 ;
        XtVaSetValues (CtrlDir, XtNlabel, "<<", NULL) ;
        if ( NetState.dir != ((unsigned char) 1) ) {
            NetState.dir = (unsigned char) 1 ;
            KesStructSlotNotify (NetStateStruct
                                 , (unsigned long) 0
                                 , DirAccessor
                                 , KEDIT_WriteWithValueMask) ;
        }
    } else if ( (fwd_p == 1) && (VideoDirection == 2) ) {
        VideoDirection = 1 ;
        XtVaSetValues (CtrlDir, XtNlabel, ">>", NULL) ;
        if ( NetState.dir != (unsigned char) 0 ) {
            NetState.dir = (unsigned char) 0 ;
            KesStructSlotNotify (NetStateStruct
                                 , (unsigned long) 0
                                 , DirAccessor
                                 , KEDIT_WriteWithValueMask) ;
        }
    }
    return ;
}


/***************************************************************************
 * Widget stuff
 ***************************************************************************/


static void StateCB (widget, u1, u2)
    Widget    widget ;
    XtPointer u1, u2 ;
{
    if ( ! VideoState ) {	/* resume */
        StartVideo () ;
    } else {			/* suspend */
        PauseVideo () ;
    }
    return ;
}

static void NextCB (widget, u1, u2) 
    Widget    widget ;
    XtPointer u1, u2 ;
{
    VideoNext () ;
    return ;
}

static void PrevCB (widget, u1, u2)
    Widget    widget ;
    XtPointer u1, u2 ;
{
    VideoPrev () ;
    return ;
}

static void QuitCB (widget, u1, u2)
    Widget    widget ;
    XtPointer u1, u2 ;
{
    exit (0) ;
}

static void DirCB (widget, u1, u2)
    Widget    widget ;
    XtPointer u1, u2 ;
{
    static Boolean fwd_p = 1 ;
    VideoDir ((VideoDirection == 1) ? 2 : 1) ;
    return ;
}
    
/* 
 * Make the window hierarchy:
 */

static void MakeWidgets (top) 
    Widget      top ;
{
    Widget         paned, box, msg, but ;

    paned = XtCreateManagedWidget ("viewer"
                                   , panedWidgetClass
                                   , top
                                   , NULL, ZERO) ;
    /* Fill the paned window (from top to bottom), with:
     * - the film 'screen'
     * - a user message zone
     * - the controls
     */
    VideoScreen = XtVaCreateManagedWidget ("screen"
                                           , simpleWidgetClass
                                           , paned
                                           , XtNwidth, VideoAttr.width
                                           , XtNheight, VideoAttr.height
                                           , XtNbackgroundPixmap, VideoPixmap
                                           , NULL) ;
    msg   = XtVaCreateManagedWidget ("message"
                                     , labelWidgetClass
                                     , paned
                                     , XtNlabel, FilmName
                                     , NULL) ;
    box   = XtCreateManagedWidget ("control"
                                   , boxWidgetClass
                                   , paned
                                   , NULL, ZERO) ;
    /* Controls are made of
     * - play/pause button
     * - next/previous (when film is paused)
     * - current frame number counter
     */
    
    CtrlPlay = XtVaCreateManagedWidget ("state"
                                        , commandWidgetClass
                                        , box
                                        , XtNlabel, "play"
                                        , NULL) ;
    XtAddCallback (CtrlPlay, XtNcallback, StateCB, (XtPointer) 0) ;

    CtrlDir = XtVaCreateManagedWidget ("direction"
                                       , commandWidgetClass
                                       , box
                                       , XtNlabel, ">>"
                                       , NULL) ;
    XtAddCallback (CtrlDir, XtNcallback, DirCB, (XtPointer) 0) ;

    CtrlNext = XtCreateManagedWidget ("next"
                                      , commandWidgetClass
                                      , box
                                      , NULL, ZERO) ;
    XtAddCallback (CtrlNext, XtNcallback, NextCB, (XtPointer) 0) ;

    CtrlPrev = XtCreateManagedWidget ("prev"
                                      , commandWidgetClass
                                      , box
                                      , NULL, ZERO) ;
    XtAddCallback (CtrlPrev, XtNcallback, PrevCB, (XtPointer) 0) ;

    but = XtCreateManagedWidget ("quit"
                                 , commandWidgetClass
                                 , box
                                 , NULL, ZERO) ;
    XtAddCallback (but, XtNcallback, QuitCB, (XtPointer) 0) ;

    XtRealizeWidget (top) ;

    XFillRectangle (XtDisplay (VideoScreen)
                    , VideoPixmap
                    , VideoGc
                    , 0, 0, VideoAttr.width, VideoAttr.height) ;
    XClearWindow (XtDisplay(VideoScreen), XtWindow (VideoScreen)) ;

    return ;
}



/*
 * Main
 */

int main (argc, argv)
    int  argc ;
    char **argv ;

{
    Widget    toplevel ;
    jmp_buf   ice_error ;
    KesServer server ;

    toplevel = XtAppInitialize (&xtapp
                                , "Xawplayer"
                                , NULL, ZERO
                                , &argc, argv
                                , NULL
                                , NULL, ZERO) ;
    if ( argc != 2 ) {
        fprintf (stderr, "Usage: xawplayer <mpeg file>\n") ;
    }
    
    if ( ! (VideoStream = MakeVideoStream (XtDisplay(toplevel), argv[1])) ) {
        fprintf (stderr, "MakeVideoStream failed.\n") ;
        exit (1) ;
    }

    XtVaSetValues(toplevel, XtNcolormap, VideoColormap, NULL);

    FilmName = argv[1] ;
    MakeWidgets (toplevel, VideoStream) ;

    if ( ! ( server = KesServerInitialize ("Xawplayer")) ) {
        fprintf (stderr, "Unable to initialize as k-Edit server.\n") ;
        exit (0) ;
    }

    KeditInitialize (server) ;
    
    if ( ! setjmp (ice_error) ) {
        KesXtServerPlug (xtapp, server, toplevel, ice_error) ;
    }
    
    XtAppMainLoop (xtapp) ;

    /* NOT REACHED */
}

    



