/* Copyright 1989-93 GROUPE BULL -- See license conditions in file COPYRIGHT */

/***************************************************************************
 * icemisc.c
 *
 * Various ICE specific requests:
 * - ByteOrder
 * - ConnectionSetup
 ***************************************************************************/

#include <stdio.h>

#include <X11/ICE/ICElib.h>
#include <X11/ICE/ICElibint.h>

/***************************************************************************
 * _IceSendByteOrder: send our byte order 
 * _IceGetByteOrder : wait for the byte order message from peer
 *
 * This is the first thing to do once a connection is setup by orig. This
 * cannot use the standard functions, because they rely on ice->swap.
 * 
 * RETURNS: void
 ***************************************************************************/

void _IceDoByteOrder (ice_conn)
    IceConn ice_conn ;

{
    _IceSendByteOrder (ice_conn) ;
    _IceGetByteOrder  (ice_conn) ;
    return ;
}

void _IceSendByteOrder (ice_conn)
    IceConn ice_conn ;

{
    iceByteOrder	request ;
    char		*preq = (char *) &request ;
    unsigned int	endian = 1 ;

    STORE_CARD8  (preq, ICE_MajorOpcode) ;
    STORE_CARD8  (preq, ICE_ByteOrder) ;
    STORE_CARD8  (preq, (*((char *) &endian)) ? ICE_LSBFirst : ICE_MSBFirst) ;
    preq += sizeof (CARD8) ;
    STORE_CARD32 (preq, (sizeof (request) - sizeof (iceHeader)) >> 3) ;

    (ice_conn->sequence_number)++ ;

    _IceSecureWrite (ice_conn, (char *) &request, sizeof (request)) ;

    return ;
}

void _IceGetByteOrder (ice_conn)
    IceConn ice_conn ;

{
    iceByteOrder request ;
    int          endian = 1 ;

    _IceSecureRead (ice_conn, (char *) &request, sizeof (request)) ;

    if ( request.byteOrder )
	ice_conn->byte_swap = *((char *) &endian) ;
    else
	ice_conn->byte_swap = ! ( *((char *) &endian) ) ;

    return ;
}

