/* Copyright 1989-93 GROUPE BULL -- See license conditions in file COPYRIGHT */

/***************************************************************************
 * iceproto.c
 *
 * Handler to the ICE protocol
 ***************************************************************************/

#include <stdio.h>

#include <X11/ICE/ICElib.h>
#include <X11/ICE/ICElibint.h>

/***************************************************************************
 * _IceProcessMessage: ICE mesage handler
 *
 * RETURN: Bool if repoly wait got.
 ***************************************************************************/

void _IcePoProcessMessage (ice_conn
			   , client_data
			   , opcode
			   , length
			   , swap
			   , reply_wait, reply_ready)
    IceConn 	     ice_conn ;
    IcePointer       client_data ;
    int     	     opcode ;
    unsigned long    length ;
    Bool             swap ;
    IceReplyWaitInfo *reply_wait ;
    Bool             *reply_ready ;
    
{
    Bool got = False ;

    switch (opcode)
    {
      case ICE_ConnectionReply:
	got = _IceProcessConnectionReply (ice_conn, length, swap, reply_wait) ;
	break ;
      case ICE_ProtocolReply:
	got = _IceProcessProtocolReply (ice_conn, length, swap, reply_wait) ;
	break ;
      default:
	fprintf (stderr, "_IcePoProcessMessage: invaliad minor %d\n", opcode) ;
	exit (1) ;
    }
    *reply_ready = got ;
    return ;
}

/***************************************************************************
 * _IcePaProcessMessage: process message 
 *
 * RETURNS: void
 ***************************************************************************/

void _IcePaProcessMessage (ice_conn, client_data, opcode, length, swap)
    IceConn       ice_conn ;
    IcePointer    client_data ;
    int           opcode ;
    unsigned long length ;
    Bool           swap ;

{
    switch (opcode) 
    {
      case ICE_ConnectionSetup:
	_IceProcessConnectionSetup (ice_conn, swap, length) ;
	break ;
      case ICE_ProtocolSetup:
	_IceProcessProtocolSetup (ice_conn, swap, length) ;
	break ;
      default:
	fprintf (stderr, "_IcePaProcessMessage: bad minor %d\n", opcode) ;
	exit (1) ;
    }

    return ;
}
